BeamAndGo.Member.Admin.Web/Pages/Admin/CreateAdmin.cshtml.cs
using System;
using System.Threading.Tasks;
using BeamAndGo.Core.Common;
using BeamAndGo.Member;
using BeamAndGo.Member.Admin;
using BeamAndGo.Member.Admin.Web.Models;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;

namespace BeamAndGo.Member.Admin.Web.Pages.Admin
{
    public class CreateAdminModel : PageModel
    {
        private readonly ILogger<CreateAdminModel> _logger; 
        private readonly IMemberAdminService _MemberAdminService;
        private readonly IMemberService _memberService;

        public bool IsXHR { get { return Request.Headers["X-Requested-With"] == "XMLHttpRequest"; } }
        public BeamAndGo.Member.Member Member { get; set; }
        public string MinExpiryDate { get; set; }


        [BindProperty]
        public DateTimeOffset? ExpiryDate { get; set; }
        [BindProperty]
        public MemberAdminAccessLevel AccessLevel { get; set; }
        [BindProperty]
        public string AdminMemberSid { get; set; }
        [BindProperty(SupportsGet = true)]
        public string SearchKeyword { get; set; }

        
        public CreateAdminModel(ILogger<CreateAdminModel> logger, 
                                IMemberAdminService MemberAdminService,
                                IMemberService memberService)
        {
            _logger = logger;
            _MemberAdminService = MemberAdminService;
            _memberService = memberService;
        }

        public IActionResult OnGet()
        {
            MinExpiryDate = DateTime.Now.ToString("yyyy-MM-dd");
            return Page();
        }

        public async Task<IActionResult> OnPostSearchAsync()
        {
            if (!string.IsNullOrEmpty(SearchKeyword))
            {
                try
                {
                    Member = await _memberService.SearchExact(SearchKeyword);

                    if (Member == null) return BadRequest("No member found");

                    return new OkObjectResult(Member);
                }
                catch (ArgumentException ex)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return BadRequest($"{ExceptionExtensions.GetDescription(ex)}");
                }
                catch (Exception ex)
                {
                    if (ex is InvalidOperationException)
                    {
                        _logger.LogInformation(ex, ex.Message);
                        return BadRequest($"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                    }
                    else
                    {
                        _logger.LogError(ex, ex.Message);
                        return BadRequest(ErrorMessage.ErrorMessageDefault.ErrorDescription);
                    }
                }
            }

            return BadRequest("Please enter keyword to search member.");
        }

        public async Task<IActionResult> OnPostAddAsync()
        {
            try
            {
                var MemberAdmin = await _MemberAdminService.Create(AdminMemberSid, AccessLevel, ExpiryDate);

                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully added a new admin");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }

            return Redirect("~/Admin/List");
        }
    }
}

BeamAndGo.Member.Admin.Web/Pages/Admin/List.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BeamAndGo.Core.Common;
using BeamAndGo.Core.Data;
using BeamAndGo.Member.Admin;
using BeamAndGo.Member.Admin.Web.Filters;
using BeamAndGo.Member.Admin.Web.Models;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;

namespace BeamAndGo.Member.Admin.Web.Pages.Admin
{
    [LoginRequired]
    [ValidateAntiForgeryToken]
    public class AdminListModel : PageModel
    {
        private readonly ApplicationOptions _applicationOptions;
        private readonly ILogger<AdminListModel> _logger;
        private readonly IMemberAdminService _MemberAdminService;


        public IEnumerable<MemberAdmin> MemberAdmins { get; private set; }
        public string MinExpiryDate { get; set; }


        [BindProperty]
        public DateTimeOffset? ExpiryDate { get; set; }
        [BindProperty(SupportsGet = true)]
        public int CurrentPage { get; set; } = 1;
        [BindProperty(SupportsGet = true)]
        public int PagesCount { get; set; } = 1;
        [BindProperty]
        public MemberAdminAccessLevel AccessLevel { get; set; }
        [BindProperty]
        public string AdminMemberSid { get; set; }
        [BindProperty(SupportsGet = true)]
        public string CurrentSearch { get; set; } = string.Empty;
        [BindProperty]
        public RecordStatus AdminRecordStatus { get; set; }


        public AdminListModel(ILogger<AdminListModel> logger,
                              IMemberAdminService MemberAdminService,
                              IOptions<ApplicationOptions> applicationOptions)
        {
            _logger = logger;
            _MemberAdminService = MemberAdminService;
            _applicationOptions = applicationOptions.Value;
        }

        public async Task<IActionResult> OnGetAsync(string search = "", int start = 0)
        {
            try
            {
                var sid = HttpContext.Session.GetString(SessionKey.MemberSid);
                var admin = await _MemberAdminService.GetByMemberSid(sid);

                if (admin.AccessLevel == MemberAdminAccessLevel.SuperAdmin)
                {
                    int count = 0;
                    start = start > 1 ? start : 1;
                    var startPage = start > 0 ? ((start - 1) * _applicationOptions.PageSize) : 0;
                    MinExpiryDate = DateTime.Now.ToString("yyyy-MM-dd");

                    if (!string.IsNullOrEmpty(search))
                    {
                        var iAsyncMemberAdmin = _MemberAdminService.Search(search, startPage);
                        MemberAdmins = iAsyncMemberAdmin.ToEnumerable();
                        count = MemberAdmins.Count();
                    }
                    else
                    {
                        MemberAdmins = await _MemberAdminService.ListAll(startPage);
                        count = await _MemberAdminService.Count();
                    }

                    CurrentPage = start;
                    CurrentSearch = search;
                    PagesCount = ((count - 1) / _applicationOptions.PageSize) + 1;
                }
                else
                {
                    string currentPageForError = Request.Path.ToString().Replace("/", " ");
                    return RedirectToPage("/Error", new { error = ErrorMessage.AccessDenied.Error, error_description = ErrorMessage.AccessDenied.ErrorDescription, error_page = currentPageForError });
                }
            }
            catch (Exception ex)
            {
                if (ex is ArgumentException || ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return RedirectToPage("/Error", new { error = ExceptionExtensions.GetCode(ex), error_description = ExceptionExtensions.GetDescription(ex) });
                }
                else
                {
                    throw;
                }
            }

            return Page();
        }

        public async Task<IActionResult> OnPostRemoveAdmin()
        {
            try
            {
                await _MemberAdminService.Delete(AdminMemberSid);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully removed admin");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }

            return Redirect("~/Admin/List");
        }

        public async Task<IActionResult> OnPostUpdateAdmin()
        {
            try
            {
                var MemberAdmin = await _MemberAdminService.Update(AdminMemberSid, AccessLevel, ExpiryDate);

                if (AdminRecordStatus != MemberAdmin.RecordStatus)
                {
                    if (AdminRecordStatus == RecordStatus.Active)
                    {
                        var memberEnable = await _MemberAdminService.Enable(AdminMemberSid);
                    }
                    else
                    {
                        var memberDisable = await _MemberAdminService.Disable(AdminMemberSid);
                    }
                }

                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully updated admin");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }

            return Redirect("~/Admin/List");
        }
    }
}

BeamAndGo.Member.Admin.Web/Pages/Member/List.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BeamAndGo.Core.Common;
using BeamAndGo.Member;
using BeamAndGo.Member.Admin;
using BeamAndGo.Member.Admin.Web.Filters;
using BeamAndGo.Member.Admin.Web.Models;
using BeamAndGo.Member.Admin.Web.ViewModels;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;

namespace BeamAndGo.Member.Admin.Web.Pages.Member
{
    [LoginRequired]
    [ValidateAntiForgeryToken]
    public class MemberListModel : PageModel
    {
        private readonly ApplicationOptions _applicationOptions;
        private readonly ILogger<MemberListModel> _logger;
        private readonly IMemberService _memberService;
        private readonly IMemberAdminService _MemberAdminService;
        

        [BindProperty(SupportsGet = true)]
        public int CurrentPage { get; set; } = 1;

        [BindProperty(SupportsGet = true)]
        public string CurrentSearch { get; set; } = string.Empty;

        [BindProperty(SupportsGet = true)]
        public int PagesCount { get; set; } = 1;

        public IEnumerable<MemberViewModel> memberList = Enumerable.Empty<MemberViewModel>();
        public IEnumerable<BeamAndGo.Member.Member> Members { get; set; }
        public bool IsReadOnly = true;
        private bool IsMasked = false;

        public MemberListModel(ILogger<MemberListModel> logger, 
                               IMemberAdminService MemberAdminService,
                               IMemberService memberService,
                               IOptions<ApplicationOptions> applicationOptions)
        {
            _logger = logger;
            _memberService = memberService;
            _MemberAdminService = MemberAdminService;
            _applicationOptions = applicationOptions.Value;
        }

        public async Task<IActionResult> OnGetAsync(string search = "", int start = 0)
        {
            try
            {
                int count = 0;
                var sid = HttpContext.Session.GetString(SessionKey.MemberSid);
                var admin = await _MemberAdminService.GetByMemberSid(sid);

                start = start > 1 ? start : 1;

                var startPage = start > 0 ? ((start - 1) * _applicationOptions.PageSize) : 0;

                if (!string.IsNullOrEmpty(search))
                {
                    var iAsyncMember = _memberService.Search(search, startPage);
                    Members = iAsyncMember.ToEnumerable(); 

                    count = Members.Count();
                }
                else
                {
                    Members = await _memberService.ListAll(startPage);

                    count = await _memberService.Count();
                }

                CurrentPage = start;
                CurrentSearch = search;
                PagesCount = ((count - 1) / _applicationOptions.PageSize) + 1;

                if (admin.AccessLevel == MemberAdminAccessLevel.FullAccess || admin.AccessLevel == MemberAdminAccessLevel.SuperAdmin)
                {
                    foreach (var member in Members)
                    {
                        memberList = memberList.Append(new MemberViewModel(member, IsMasked));
                    }

                    IsReadOnly = false;
                }
                else if (admin.AccessLevel == MemberAdminAccessLevel.ReadOnlyUnmasked)
                {
                    foreach (var member in Members)
                    {
                        memberList = memberList.Append(new MemberViewModel(member, IsMasked));
                    }
                }
                else if (admin.AccessLevel == MemberAdminAccessLevel.ReadOnlyMasked)
                {
                    IsMasked = true;

                    foreach (var member in Members)
                    {
                        memberList = memberList.Append(new MemberViewModel(member, IsMasked));
                    }
                }
                else
                {
                    string currentPageForError = Request.Path.ToString().Replace("/", " ");
                    return RedirectToPage("/Error", new { error = ErrorMessage.AccessDenied.Error, error_description = ErrorMessage.AccessDenied.ErrorDescription, error_page = currentPageForError });
                }
            }
            catch (Exception ex)
            {
                if (ex is ArgumentException || ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return RedirectToPage("/Error", new { error = ExceptionExtensions.GetCode(ex), error_description = ExceptionExtensions.GetDescription(ex) });
                }
                else
                {
                    throw;
                }
            }

            return Page();
        }
    }
}

BeamAndGo.Member.Admin.Web/Pages/Admin/CreateAdmin.cshtml
@page "{handler?}"
@model BeamAndGo.Member.Admin.Web.Pages.Admin.CreateAdminModel
@{
    ViewData["Title"] = "Create Admin";
    if (Model.IsXHR) Layout = null;
    else Layout = "_Layout";

}

<div class="uk-margin-small">
    <h3 class="uk-text">Search Member</h3>
    <i>Find a person by email or phone number.</i>
    <div class="uk-margin-small">
        <form class="uk-search uk-search-default uk-width-1-1" asp-page-handler="search" asp-antiforgery="true" method="post" data-ajax="true" data-ajax-method="post" data-ajax-success="searchSuccess" data-ajax-failure="searchFailed">
            <button class="uk-search-icon-flip" uk-search-icon type="submit"></button>
            <input class="uk-search-input" asp-for="SearchKeyword" type="search" placeholder="email or phone number">
        </form>
    </div>
</div>

<!-- This is the modal -->
<div id="modal-search-result" uk-modal>
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body">
            <div class="uk-card uk-card-default uk-card-small uk-card-body">
                <form asp-page-handler="add" method="post" asp-antiforgery="true">
                    <div class="uk-margin-small uk-grid-small" uk-grid>
                        <div class="uk-width-1-3 uk-text-center">
                            <div class="uk-margin-small">
                                <span class="uk-icon" uk-icon="icon: user; ratio: 5.0"></span>
                            </div>
                            <div class="uk-margin-small">
                                <input id="search-member-sid" asp-for="AdminMemberSid" type="hidden">
                                <label id="search-member-name" class="uk-text-medium" />
                            </div>
                        </div>
                        <div class="uk-width-2-3">
                            <div class="uk-margin-small">
                                <label class="uk-form-label">Access Level</label>
                                <div>
                                    <select required class="uk-select uk-width-1-1" id="accessLevel" asp-for="AccessLevel" asp-items="Html.GetEnumSelectList<MemberAdminAccessLevel>()">
                                        <option selected value="" disabled>Select Access Level</option>
                                    </select>
                                </div>
                            </div>
                            <div class="uk-margin-small">
                                <input class="set-expiryDate-create uk-checkbox" type="checkbox" checked="checked" onchange="valueCreateChanged()">
                                <label class="uk-form-label">Expiration Date</label>
                            </div>
                            <div class="uk-margin-small">
                                <input asp-for="@Model.ExpiryDate" class="uk-input" id="CreateExpirydatePicker" type="date" value="@Model.ExpiryDate" min="@Model.MinExpiryDate" placeholder="YYYY-MM-DD" />
                            </div>
                        </div>
                    </div>
                    <div class="uk-margin-small uk-text-right">
                        <button class="uk-button uk-button-primary uk-width-1-4@s" type="submit">Add</button>
                        <button class="uk-button uk-button-default uk-width-1-4@s" type="button" uk-toggle="target: #bng-modal">Cancel</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
<!-- End of modal -->
<!-- This is the modal -->
<div id="modal-search-noresult" uk-modal>
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body">
            <p class="uk-text-center"><i>No Member were found.</i></p>
            <div class="uk-margin-small uk-text-center">
                <div class="uk-margin-small uk-text-center">
                    <button class="uk-button uk-button-primary" type="button" uk-toggle="target: #bng-modal">Search Again</button>
                </div>
            </div>
        </div>
    </div>
</div>
<!-- End of modal -->

<script>
    // Search
    searchSuccess = (member) => {
        $('#search-member-sid').val(member.sid);
        $('#search-member-name').text(member.firstName + " " + member.lastName);
        UIkit.modal('#modal-search-result').show();
        //reloadIfNotXHR();
    };
    searchFailed = (xhr) => {
        UIkit.modal('#modal-search-noresult').show();
    };
    function valueCreateChanged() {
        if ($('.set-expiryDate-create').is(":checked"))
            $("#CreateExpirydatePicker").show();
        else
            $("#CreateExpirydatePicker").hide();
    }
</script>